
# norootforbuild
%define         configfiles     configfiles.list

Name:           open-xchange-gui
BuildArch: 	noarch
#!BuildIgnore: post-build-checks
BuildRequires:  ant
BuildRequires:  ant-nodeps
BuildRequires:  java-devel >= 1.6.0
#BuildRequires:  ant ant-nodeps ant-apache-regexp ant-trax gettext-devel
Version:	6.22.5
%define		ox_release 5
Release:	%{ox_release}_<CI_CNT>.<B_CNT>
Group:          Applications/Productivity
License:        Creative Commons Attribution-Noncommercial-Share Alike 2.5 Generic
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
URL:            http://www.open-xchange.com/
Source:         %{name}_%{version}.orig.tar.bz2
Summary:        Package containing the AJAX gui
%if 0%{?suse_version}
Requires:	apache2
%endif
%if 0%{?fedora_version} || 0%{?rhel_version}
Requires:	httpd
%endif
Requires:	open-xchange-gui-theme-default open-xchange-gui-login-theme-default open-xchange-gui-loading-theme-default open-xchange-gui-l10n-en-us

%description
Package containing the AJAX gui

Authors:
--------
    Open-Xchange

#----------------------------------------------------------------------
%package        themes-default
Group:          Applications/Productivity
Summary:        Package containing the default themes
Provides:       open-xchange-gui-theme-default

%description    themes-default
Package containing the default themes

Authors:
--------
    Open-Xchange

#----------------------------------------------------------------------
%package        login-theme-default
Group:          Applications/Productivity
Summary:        Package containing the login theme

%description    login-theme-default
Package containing the login theme

Authors:
--------
    Open-Xchange

#----------------------------------------------------------------------
%package        loading-theme-default
Group:          Applications/Productivity
Summary:        Package containing the loading theme

%description    loading-theme-default
Package containing the loading theme

Authors:
--------
    Open-Xchange

%prep
%setup -q

%build

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
%if 0%{?rhel_version} || 0%{?fedora_version}
%define docroot /var/www/html
%else
%define docroot /srv/www/htdocs
%endif

export ANT_OPTS="-Dfile.encoding=UTF-8 -Djavax.xml.transform.TransformerFactory=net.sf.saxon.TransformerFactoryImpl"
ant -lib lib -Ddestdir=%{buildroot} -Dhtdoc=%{docroot}/ox6 -Dhelplocation=help -Dskip.language=true install
ant -lib lib -Ddestdir=%{buildroot} -Dhtdoc=%{docroot}/ox6 -Dhelplocation=help -Dskip.language=true install-themes

mkdir -p %{buildroot}/opt/open-xchange/etc
mkdir -p %{buildroot}/opt/open-xchange/lib
install -m 644 etc/guipluginfunctions.sh %{buildroot}/opt/open-xchange/lib/guipluginfunctions.sh
# compat link; if not present, old postrms of gui plugins will fail
ln -sf ../lib/guipluginfunctions.sh %{buildroot}/opt/open-xchange/etc/guipluginfunctions.sh
rm -f %{configfiles}
find %{buildroot}/%{docroot}/ox6 -type f -not -regex ".*ox6/themes/.*/.*" -not \( -name languages.js -a -name static.conf \) -printf '"%p"\n' > %{configfiles}
perl -pi -e 's;%{buildroot}/;;' %{configfiles}

%clean
%{__rm} -rf %{buildroot}

%files -f %{configfiles}
%defattr(-,root,root)
%dir %{docroot}/ox6
%dir /opt/open-xchange/etc
%dir /opt/open-xchange/lib
/opt/open-xchange/etc/*
/opt/open-xchange/lib/*
%config(noreplace) %{docroot}/ox6/plugins/static.conf
%doc ChangeLog

%files themes-default
%defattr(-,root,root)
%{docroot}/ox6/themes/default
%{docroot}/ox6/themes/light_breeze

%files login-theme-default
%defattr(-,root,root)
%{docroot}/ox6/themes/login

%files loading-theme-default
%defattr(-,root,root)
%{docroot}/ox6/themes/loading

%changelog
* Wed Nov 20 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Fifth candidate for 6.22.5 release
* Mon Nov 18 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-11-19
* Fri Nov 15 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Fourth candidate for 6.22.5 release
* Mon Nov 11 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-11-12
* Thu Nov 07 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Third candidate for 6.22.5 release
* Tue Nov 05 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-11-12
* Wed Oct 23 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Second candidate for 6.22.5 release
* Thu Oct 10 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
First sprint increment for 6.22.5 release
* Tue Sep 24 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Eleventh candidate for 6.22.4 release
* Fri Sep 20 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
prepare for 6.22.5 release
* Fri Sep 20 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Tenth candidate for 6.22.4 release
* Thu Sep 12 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Ninth candidate for 6.22.4 release
* Sun Sep 01 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Eighth candidate for 6.22.4 release
* Tue Aug 27 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Seventh candidate for 6.22.4 release
* Fri Aug 23 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Sixth candidate for 6.22.4 release
* Mon Aug 19 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Fifth release candidate for 6.22.4
* Wed Aug 14 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-08-09
* Tue Aug 13 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Fourth release candidate for 6.22.4
* Tue Aug 06 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Third release candidate for 6.22.4
* Fri Aug 02 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Second release candidate for 6.22.4
* Wed Jul 17 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
First release candidate for 6.22.4
* Tue Jul 16 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
prepare for 6.22.4
* Mon Jul 01 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Third candidate for 6.22.3 release
* Fri Jun 28 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Second candidate for 6.22.3 release
* Wed Jun 26 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
First candidate for 6.22.3 release
* Wed Jun 26 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
prepare for 6.22.3
* Thu Jun 20 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-06-13
* Tue Jun 11 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-06-13
* Mon May 27 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-04-30
* Mon Apr 22 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-04-30
* Wed Mar 27 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-04-04
* Mon Mar 18 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-03-19
* Tue Mar 12 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Sixth release candidate for 6.22.2
* Mon Mar 11 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Fifth release candidate for 6.22.2
* Mon Mar 11 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Fourth release candidate for 6.22.2
* Fri Mar 08 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Third release candidate for 6.22.2
* Thu Mar 07 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Second release candidate for 6.22.2
* Wed Feb 27 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
First release candidate for 6.22.2
* Wed Feb 20 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
prepare for 6.22.2 release
* Fri Feb 15 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-02-13
* Mon Jan 28 2013 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2013-01-28
* Mon Nov 26 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2012-11-28
* Wed Nov 14 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Sixth release candidate for 6.22.1
* Tue Nov 13 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Fifth release candidate for 6.22.1
* Tue Nov 06 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Fourth release build for 6.22.1
* Mon Nov 05 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Third release build for 6.22.1
* Wed Oct 31 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Second release candidate for 6.22.1
* Wed Oct 31 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Build for patch 2012-10-31
* Fri Oct 26 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
First release candidate for 6.22.1
* Fri Oct 26 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
prepare for 6.22.1
* Wed Oct 10 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Fifth release candidate for 6.22.0
* Tue Oct 09 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Fourth release candidate for 6.22.0
* Fri Oct 05 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Third release candidate for 6.22.0
* Fri Oct 05 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Second release candidate for 6.22.0
* Tue Aug 21 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
First release candidate for 6.22.0
* Tue Aug 21 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
prepare for 6.22.0
* Thu Aug 09 2012 Viktor Pracht <viktor.pracht@open-xchange.com>
Migrated to Git
